Check pipeline quality
POST https://{controlplane_path}/api/1/rest/public/pipeline/linter/{path}
This API provides a clear complete report for all standard checks, including message levels (Critical, Warning, Info) with actionable message descriptions for the pipeline quality.
Prerequisites
- You must be a member of the Environment/Org to use this linter.
Path parameters
| Key | Description |
|---|---|
controlplane_path |
Required. The SnapLogic control plane host:
elastic.snaplogic.com (US) or
emea.snaplogic.com (EU). |
path |
The absolute path to the pipeline. Use one of the following formats:
|
Request header
This API supports two authentication methods. Use one of the following:
Basic authentication
To use basic authentication, specify Basic for authorization in the request
header, add your credentials (email and password for your SnapLogic user or service account), and
specify application/json for content type. For example:
Authorization: Basic {base64_encoded <email>:<password>}
Content-Type: application/json
Example of basic authentication using Postman:
JWT authentication
When using JWT authentication, the API request includes specific headers. In the request header,
specify Bearer Token for authorization, add the token, and specify
application/json for content type. These headers are automatically added when
you configure bearer token authentication in your API client. The authorization header contains
the word Bearer followed by a space and your JWT.
Authorization: Bearer Token {token}
Content-Type: application/json
Example of JWT authentication using Postman:
Request body
None.
Response
{
"response_map": {
"complete_report": [
{
"key": 0,
"name": "...",
"description": "...",
"message_level": "...",
"disabled": false
}
]
},
"http_status_code": 200
}
| Key | Type | Description |
|---|---|---|
key |
number | Number of the rule. |
name |
string | Name of the pipeline check. |
description |
string | Description of the pipeline check result. null when
disabled is true. |
message_level |
string | Severity of the check: Info, Warning, or
Critical. null when disabled is
true. |
disabled |
boolean | Whether this linter rule was evaluated. false means the rule
is active and description and message_level
contain a result. true means the rule is switched off on the
server; description and message_level are
null for disabled rules. The API always returns all rules, both
active and disabled. |
For detailed description of the Warnings and Critical messages refer to the individual tab in the following table:
- Warning
- Critical
| Key | Description |
|---|---|
| 1 | Pipeline has no notes. |
| 2 | Pipeline has bad characters in the Name (Label). |
| 3 | There is no Error Handling in the pipeline. |
| 7 | Child pipelines do not conform to standard naming convention. |
| 8 | Expression libraries have bad/unsupported naming conventions. |
| 9 | There are too many Snaps (greater than 50). |
| 11 | There are too many go-to links (greater than 5). |
| 13 | Mapper Snap contains Target path names that are non-standard. |
| 15 | Mapper Snap may contain nested ternary statements. |
| 16 | Custom Snap usage detected in the pipeline. |
| 17 | Mapper Snap contains call to
Date.now(). |
| 18 | Snap label has not been significantly changed from default (Example: Mapper1, Copy3). |
| 19 |
Deprecated Snap used in the pipeline. The following Snaps are considered deprecated:
|
| 20 | File Writer is present in the pipeline. |
| 23 | Group By Fields Snap is present in the pipeline. |
| 24 | Group By N Snap configured with large Group Size value. |
| 25 | In-Memory Lookup Snap is present in the pipeline. |
| 27 | Snap Info tab / Notes section should not be empty. |
| 28 | Snap Info tab / Notes section content is too similar to the Snap label or default Snap label. |
| 29 | Pipeline executed by Pipeline Execute Snap should be prefixed. |
| 30 | Pipeline Execute Snap label should be similar to the pipeline executed to make it easy to identify. |
| 31 | Pipeline executed by Pipeline Execute Snap should have a name similar to the calling pipeline. |
| 32 | Pipeline is calling a child via Pipeline Execute Snap and should be prefixed. |
| 33 | Pipeline is calling a child via Pipeline Execute Snap and should be suffixed. |
| 34 | The Execution Label setting in the Pipeline Execute Snap is too similar to the pipeline name being called. |
| 38 | Script Snap is present in the pipeline. |
| 39 | Sort Snap configured with Maximum memory % greater than 10%. |
| 41 | Mapper Snap is not using Pass through and configured with more than 40 entries. |
| Key | Description |
|---|---|
| 4 | Use of duplicate Snap labels. |
| 5 | More than one unlinked output view. |
| 6 | Presence of disabled Snaps. |
| 10 | Exceeds the Max Snap Count of 100. |
| 12 | Aggregate Snap is using unsorted input. |
| 14 | Binary to Document Snap used, which pushes all input documents into memory. |
| 21 | Gate Snap is present in the pipeline, pushing all incoming documents to memory. The Gate Snap refers to the Transform-Aggregate Snap. |
| 22 | Group By N Snap is present in the pipeline. |
| 26 | Join Snap is using Unsorted input. |
| 35 | Pipeline Execute Snap appears to be recursively calling the executing pipeline. |
| 36 | Pipeline Execute Snap is configured with Execute On as SNAPLEX_WITH_PATH and Snaplex path as pipe.plexPath. |
| 37 | Record Replay Snap used and should not be migrated to production. |
| 40 | Snap represents a pipeline that has been nested into the current pipeline. |
| 42 | The XML Parser Snap is being used without the Splitter property enabled. |
Example
The example provided below displays only a few selected Warning and Critical messages for reference:
{
"response_map": {
"complete_report": [
{
"key": 1,
"name": "No Notes",
"description": "Pipeline does not have notes",
"message_level": "Warning",
"disabled": false
},
{
"key": 2,
"name": "Bad characters in the Name (Label)",
"description": "Pipeline does not have bad characters in the name/label",
"message_level": "Info",
"disabled": false
},
{
"key": 3,
"name": "No Error Handling",
"description": "Pipeline does not have error handling",
"message_level": "Warning",
"disabled": false
},
{
"key": 4,
"name": "Use of duplicate Snap Labels",
"description": "Pipeline has use of duplicate snap labels",
"message_level": "Critical",
"disabled": false
},
{
"key": 5,
"name": "Presence of disabled Snaps",
"description": "Pipeline has presence of disabled Snaps",
"message_level": "Critical",
"disabled": false
}
]
},
"http_status_code": 200
}